-- name: [CS] \\#FDD303\\Dragon Ball Modpack
-- description: Adds the Lobby Avatars models from Dragon Ball FighterZ as custom characters!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = "Dragon Ball FighterZ Modpack"
local TEXT_MOD_VERSION = "1.0"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_GOKU = get_texture_info("goku-icon")
local TEX_VEGETA = get_texture_info("vegeta-icon")

local VOICETABLE_GOKU = {
    [CHAR_SOUND_ATTACKED] = {'vgkn000.ogg','vgkn001.ogg','vgkn002.ogg','vgkn007.ogg','vgkn022.ogg','vgkn027.ogg'},
    [CHAR_SOUND_DOH] = {'vgkn011.ogg','vgkn015.ogg','vgkn020.ogg','vgkn024.ogg','vgkn025.ogg'},
    [CHAR_SOUND_DROWNING] = 'vgkn030.ogg',
    [CHAR_SOUND_DYING] = {'vgkn028.ogg','vgkn503.ogg'},
    [CHAR_SOUND_EEUH] = {'vgkn023.ogg','vgkn126.ogg'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'vgkn124.ogg','vgkn125.ogg'},
    [CHAR_SOUND_HAHA] = 'vgkn026.ogg',
    [CHAR_SOUND_HAHA_2] = 'vgkn026.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'vgkn026.ogg','vgkn120.ogg','vgkn122.ogg','vgkn128.ogg','vgkn200.ogg','vgkn206.ogg','vgkn211.ogg','vgkn213.ogg','vgkn218.ogg','vgkn219.ogg','vgkn404.ogg','vgkn603.ogg','vgkn702.ogg'},
    [CHAR_SOUND_HOOHOO] = {'vgkn101.ogg','vgkn107.ogg','vgkn109.ogg','vgkn606.ogg'},
    [CHAR_SOUND_HRMM] = 'vgkn021.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'vgkn131.ogg',
    [CHAR_SOUND_MAMA_MIA] = {'vgkn012.ogg','vgkn013.ogg','vgkn010.ogg','vgkn016.ogg','vgkn017.ogg','vgkn018.ogg','vgkn019.ogg','vgkn031.ogg','vgkn112.ogg','vgkn117.ogg','vgkn212.ogg','vgkn110.ogg'},
    [CHAR_SOUND_LETS_A_GO] = {'vgkn114.ogg','vgkn400.ogg','vgkn401.ogg','vgkn402.ogg','vgkn403.ogg','vgkn502.ogg','vgkn504.ogg','vgkn505.ogg','vgkn507.ogg','vgkn601.ogg','vgkn602.ogg'},
    [CHAR_SOUND_ON_FIRE] = 'vgkn032.ogg',
    [CHAR_SOUND_OOOF] = {'vgkn005.ogg','vgkn006.ogg'},
    [CHAR_SOUND_OOOF2] = {'vgkn005.ogg','vgkn006.ogg'},
    [CHAR_SOUND_PUNCH_HOO] = {'vgkn102.ogg','vgkn105.ogg'},
    [CHAR_SOUND_PUNCH_WAH] = {'vgkn101.ogg','vgkn104.ogg'},
    [CHAR_SOUND_PUNCH_YAH] = {'vgkn100.ogg','vgkn103.ogg'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'vgkn108.ogg','vgkn111.ogg','vgkn115.ogg','vgkn118.ogg','vgkn119.ogg','vgkn121.ogg','vgkn123.ogg','vgkn127.ogg','vgkn134.ogg','vgkn201.ogg','vgkn203.ogg','vgkn204.ogg','vgkn206.ogg','vgkn211.ogg','vgkn213.ogg','vgkn214.ogg','vgkn604.ogg','vgkn609.ogg','vgkn610.ogg','vgkn612.ogg','vgkn614.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'vgkn116.ogg',
    [CHAR_SOUND_UH] = {'vgkn003.ogg','vgkn004.ogg'},
    [CHAR_SOUND_UH2] = {'vgkn003.ogg','vgkn004.ogg'},
    [CHAR_SOUND_UH2_2] = {'vgkn003.ogg','vgkn004.ogg'},
    [CHAR_SOUND_WAAAOOOW] = {'vgkn029.ogg','vgkn009.ogg','vgkn010.ogg','vgkn014.ogg'},
    [CHAR_SOUND_WAH2] = {'vgkn215.ogg','vgkn216.ogg','vgkn217.ogg','vgkn220.ogg','vgkn202.ogg','vgkn205.ogg'},
    [CHAR_SOUND_WHOA] = 'vgkn113.ogg',
    [CHAR_SOUND_YAHOO] = 'vgkn500.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'vgkn102.ogg','vgkn104.ogg','vgkn607.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'vgkn106.ogg','vgkn124.ogg'},
    [CHAR_SOUND_HELLO] = 'vgkn600.ogg',
}

local VOICETABLE_VEGETA = {
    [CHAR_SOUND_ATTACKED] = {'vvgn000.ogg','vvgn001.ogg','vvgn002.ogg','vvgn005.ogg','vvgn017.ogg','vvgn603.ogg'},
    [CHAR_SOUND_DOH] = {'vvgn003.ogg','vvgn004.ogg'},
    [CHAR_SOUND_DROWNING] = {'vvgn012.ogg','vvgn014.ogg'},
    [CHAR_SOUND_DYING] = {'vvgn012.ogg','vvgn014.ogg'},
    [CHAR_SOUND_EEUH] = {'vvgn013.ogg','vvgn016.ogg'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'vvgn106.ogg','vvgn107.ogg'},
    [CHAR_SOUND_HAHA] = {'vvgn020.ogg','vvgn100.ogg'},
    [CHAR_SOUND_HAHA_2] = {'vvgn020.ogg','vvgn100.ogg'},
    [CHAR_SOUND_HERE_WE_GO] = {'vvgn029.ogg','vvgn114.ogg','vvgn119.ogg','vvgn121.ogg','vvgn128.ogg','vvgn129.ogg','vvgn207.ogg','vvgn212.ogg','vvgn214.ogg','vvgn215.ogg','vvgn217.ogg','vvgn404.ogg','vvgn405.ogg','vvgn502.ogg','vvgn600.ogg','vvgn601.ogg','vvgn701.ogg','vvgn702.ogg','vvgn703.ogg','vvgn704.ogg'},
    [CHAR_SOUND_HOOHOO] = 'vvgn124.ogg',
    [CHAR_SOUND_HRMM] = {'vvgn024.ogg','vvgn126.ogg'},
    [CHAR_SOUND_MAMA_MIA] = {'vvgn008.ogg','vvgn009.ogg','vvgn018.ogg','vvgn019.ogg','vvgn031.ogg','vvgn032.ogg','vvgn112.ogg','vvgn120.ogg','vvgn125.ogg','vvgn211.ogg','vvgn504.ogg','vvgn506.ogg'},
    [CHAR_SOUND_LETS_A_GO] = {'vvgn030.ogg','vvgn122.ogg','vvgn400.ogg','vvgn401.ogg','vvgn402.ogg','vvgn403.ogg','vvgn500.ogg','vvgn505.ogg','vvgn507.ogg','vvgn602.ogg'},
    [CHAR_SOUND_ON_FIRE] = {'vvgn028.ogg','vvgn116.ogg'},
    [CHAR_SOUND_OOOF] = {'vvgn006.ogg','vvgn015.ogg','vvgn023.ogg'},
    [CHAR_SOUND_OOOF2] = {'vvgn006.ogg','vvgn015.ogg','vvgn023.ogg'},
    [CHAR_SOUND_PUNCH_HOO] = 'vvgn103.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'vvgn102.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'vvgn101.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'vvgn.ogg026','vvgn027.ogg','vvgn104.ogg','vvgn105.ogg','vvgn109.ogg','vvgn110.ogg','vvgn111.ogg','vvgn113.ogg','vvgn115.ogg','vvgn117.ogg','vvgn118.ogg','vvgn123.ogg','vvgn127.ogg','vvgn134.ogg','vvgn200.ogg','vvgn201.ogg','vvgn202.ogg','vvgn203.ogg','vvgn204.ogg','vvgn205.ogg','vvgn208.ogg','vvgn213.ogg','vvgn214.ogg','vvgn216.ogg','vvgn217.ogg','vvgn218.ogg','vvgn219.ogg','vvgn220.ogg','vvgn501.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'vvgn020.ogg',
    [CHAR_SOUND_UH] = {'vvgn006.ogg','vvgn015.ogg','vvgn023.ogg'},
    [CHAR_SOUND_UH2] = {'vvgn006.ogg','vvgn015.ogg','vvgn023.ogg'},
    [CHAR_SOUND_UH2_2] = {'vvgn006.ogg','vvgn015.ogg','vvgn023.ogg'},
    [CHAR_SOUND_WAAAOOOW] = {'vvgn010.ogg','vvgn011.ogg','vvgn028.ogg','vvgn116.ogg'},
    [CHAR_SOUND_WAH2] = {'vvgn104.ogg','vvgn105.ogg','vvgn200.ogg','vvgn201.ogg','vvgn202.ogg','vvgn203.ogg'},
    [CHAR_SOUND_WHOA] = 'vvgn007.ogg',
    [CHAR_SOUND_YAHOO] = 'vvgn206.ogg','vvgn209.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'vvgn108.ogg','vvgn206.ogg','vvgn210.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'vvgn021.ogg','vvgn022.ogg','vvgn025.ogg'},
}

-- Load Models
local E_MODEL_GOKU = smlua_model_util_get_id("goku_geo")
local E_MODEL_VEGETA = smlua_model_util_get_id("vegeta_geo")

--Load Cap Models
local CAPTABLE_NOCAP = {
    normal = smlua_model_util_get_id("nocap_normal_geo"),
    wing = smlua_model_util_get_id("nocap_wings_geo"),
    metal = smlua_model_util_get_id("nocap_normal_geo"),
    metalWing = smlua_model_util_get_id("nocap_wings_geo"),
}

-- Character Initialize
local CT_GOKU = _G.charSelect.character_add("Goku", {"Hey, it's me, Goku!"}, "Arc System Works / Gabrimer", {r = 231, g = 118, b = 41}, E_MODEL_GOKU, CT_MARIO, TEX_GOKU)
                    -- Add Voices, Palette and Caps
                    _G.charSelect.character_add_voice(E_MODEL_GOKU, VOICETABLE_GOKU)
                    _G.charSelect.character_add_caps(E_MODEL_GOKU, CAPTABLE_NOCAP)
local CT_VEGETA = _G.charSelect.character_add("Vegeta", {"Allow me to show you a power you could never achieve."}, "Arc System Works / Gabrimer", {r = 33, g = 67, b = 189}, E_MODEL_VEGETA, CT_MARIO, TEX_VEGETA)
                    -- Add Voices, Palette and Caps
                    _G.charSelect.character_add_voice(E_MODEL_VEGETA, VOICETABLE_VEGETA)
                    _G.charSelect.character_add_caps(E_MODEL_VEGETA, CAPTABLE_NOCAP)

-- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_GOKU
    or v == VOICETABLE_VEGETA
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_GOKU
    or v == VOICETABLE_VEGETA
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)